#
# replace words and numbers in input text
# the intent is the words being replaced are abbreviations
# or numbers 0 .. 10; both are replaced with expansions
#
# assumptionss:
# * words to be replaced are in file "abbreviations.txt"
# * numbers to be replaced are in file "abbreviations-num.txt"
# * input is in file "abbrev-input.txt"
#
# the frmat of the first two is given in the header comment
# of the function funct(), which loads them
#
# this uses the get method, but could equally well be done
# by seeing if the key is in the dictionary
#
# Matt Bishop, MHI 289I, Fall 2020
#

import sys      # this has the exit method 

#
# create a dictionary from the contents of file fname
# assume the lines of the file are:
#   abbreviation<tab char>expansion
# WARNING: NO CHECKING OF FORMAT OF FILE CONTENTS
# return the dictionary
#
def loaddict(dname):
    # open the dictionary; if it fails, return error value
    try:
        dhandle = open(dname, "r")
        dabbrev = dict()
    except Exception as msg:
        print("Could not open", dname)
        print(mesg)
        return None
    for line in dhandle:
        line = line.strip()
        parts = line.split('\t')
        dabbrev[parts[0]] = parts[1]
    return dabbrev

#
# this does the actual dictionary loading
# on error, funct returns None, which is like False
# in an "if" statement's condition
#
abbrev = loaddict("abbreviations.txt")
if not abbrev:
    print("Could not load abbreviations; quit")
    sys.exit(1)
numbers = loaddict("abbreviations-num.txt")
if not numbers:
    print("Could not load abbreviations; quit")
    sys.exit(1)

#
# now open the input file and give error if that fails
#
try:
    infile = open("abbrev-input.txt", "r")
except Exception as msg:
    print("Could not open", dname)
    print(mesg)
    sys.exit(1)

#
# process the input
#
for line in infile:
    # break line into words separated by spaces
    # (blanks, tabs, newlines, a few other characters)
    words = line.split()
    # go through the words replacing abbreviations and numbers
    for word in words:
        # if it's an abbreviation, replace it; otherwise don't
        outword = abbrev.get(word, word)
        # if it's a number, replace it; otherwise don't
        outword = numbers.get(word, word)
        # print out the (possibly transformed) word
        print(outword, end=' ')
    # now end the line
    print(" ")
